;##################################################################
; LVDesktop9xNT
;##################################################################

#include "LVDesktop9xNT.Inc"

; Interprocess memory allocation for 9x
Alloc = COMCTL32.DLL:71
ReAlloc = COMCTL32.DLL:72
Free = COMCTL32.DLL:73
GetSize = COMCTL32.DLL:74

/*
invoke Alloc, cb ; Ordinal COMCTL32.DLL:71
Returns pv (pointer to virtual memory)

invoke ReAlloc, pv, cb ; Ordinal COMCTL32.DLL:72
Returns pv (pointer to virtual memory)

invoke Free, pv ; Ordinal COMCTL32.DLL:73
Returns Non-zero

invoke GetSize, pv ; Ordinal COMCTL32.DLL:74
Returns bytes allocated
*/

.CONST
	IDD_DLG1	equ			1000

.DATA
	icc	 		DQ			3FFF00000008h

	hInstance	DD 			?
	hListView	DD			?
	pt			POINT		<>
	lvi			LV_ITEM		<>
	lvtext		DB			256 DUP (?)
	
	lbfmt		DB			"%u: %s x=%u y=%u",0

	pGetWindowThreadProcessId	DD ?
	pVirtualAllocEx	DD ?
	pWriteProcessMemory	DD ?
	pReadProcessMemory	DD ?
	pVirtualFreeEx	DD ?

.CODE

Start:

	invoke GetModuleHandle,0
	mov [hInstance],eax
	invoke Is9x
	or eax,eax
	jnz >
	invoke LoadNTMemoryFunctions
	:
	invoke InitCommonControls ;Ex,OFFSET icc
	invoke DialogBoxParam,[hInstance],IDD_DLG1,0,ADDR DlgProc,0
	invoke ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam
	uses esi,edi
	LOCAL buffer[256]	:B

	cmp D[uMsg],WM_INITDIALOG
	jne >>.WM_COMMAND
		call FindListview
		invoke SendMessage,[hListView],LVM_GETITEMCOUNT,0,0
		mov edi,eax
	
		mov D[lvi.imask],LVIF_TEXT
		mov D[lvi.pszText],OFFSET lvtext
		mov D[lvi.cchTextMax],255
	
		mov esi,0
		jmp >L2
			L1:
			mov D[lvi.iItem],esi
			invoke GetRemoteItem,[hListView],OFFSET lvi
			invoke GetItemPos,[hListView],[lvi.iItem],offset pt
			invoke wsprintf,addr buffer,offset lbfmt,esi,OFFSET lvtext,[pt.x],[pt.y]
			add esp,20
			invoke SendDlgItemMessage,[hwnd],1001,LB_ADDSTRING,0,addr buffer
			inc esi
			L2:
		cmp esi,edi
		jl <L1

		jmp >.EXIT

	.WM_COMMAND
	cmp D[uMsg],WM_COMMAND
	jne >.WM_CLOSE
		jmp >.EXIT

	.WM_CLOSE
	cmp D[uMsg],WM_CLOSE
	jne >.DEFPROC
		INVOKE EndDialog,[hwnd],0

	.DEFPROC
		mov eax,FALSE
		ret

	.EXIT

	mov eax, TRUE
	ret
ENDF

FindListview:
	invoke FindWindow, "progman", 0
	invoke FindWindowEx, eax, 0, "SHELLDLL_DefView", 0
	invoke FindWindowEx, eax, 0, "SysListView32", 0
	mov [hListView], eax
	ret

LoadNTMemoryFunctions FRAME
	LOCAL hLib		:D
	
	invoke GetModuleHandle,"User32.dll"
	mov [hLib],eax
	
	invoke GetProcAddress,[hLib],"GetWindowThreadProcessId"
	mov [pGetWindowThreadProcessId],eax
	
	invoke GetModuleHandle,"Kernel32.dll"
	mov [hLib],eax
	
	invoke GetProcAddress,[hLib],"VirtualAllocEx"
	mov [pVirtualAllocEx],eax
	
	invoke GetProcAddress,[hLib],"WriteProcessMemory"
	mov [pWriteProcessMemory],eax
	
	invoke GetProcAddress,[hLib],"ReadProcessMemory"
	mov [pReadProcessMemory],eax
	
	invoke GetProcAddress,[hLib],"VirtualFreeEx"
	mov [pVirtualFreeEx],eax

	RET
ENDF

Is9x FRAME
	LOCAL osvi	:OSVERSIONINFO
	/*
	Returns FALSE for NT
			TRUE for Windows 9x
			2 for Windows 95
	*/

	mov D[osvi.dwOSVersionInfoSize],SIZEOF OSVERSIONINFO
	invoke GetVersionEx,offset osvi
	
	xor eax,eax
	cmp D[osvi.dwPlatformId],VER_PLATFORM_WIN32_WINDOWS
	jne >
		inc eax
		cmp D[osvi.dwMinorVersion],0
		jne >
		inc eax
	:

	RET
ENDF

GetItemPos FRAME hlv,iItem,pPoint
	call Is9x
	or eax,eax
	jz >
		invoke GetItemPos9x,[hlv],[iItem],[pPoint]
		RET
	:
		invoke GetItemPosNT,[hlv],[iItem],[pPoint]
		RET
ENDF

GetRemoteItem FRAME hlv,pLVItem
	call Is9x
	or eax,eax
	jz >
		invoke GetRemoteItem9x,[hlv],[pLVItem]
		RET
	:
		invoke GetRemoteItemNT,[hlv],[pLVItem]
		RET
ENDF

GetItemPos9x FRAME hlv,iItem,pPoint
	LOCAL pMem		:D

	; allocate memory on the shared heap
	invoke Alloc,8
	mov [pMem],eax

	; Get the item position and place it in the shared buffer
	invoke SendMessage,[hlv],LVM_GETITEMPOSITION,[iItem],[pMem]

	; Copy the shared buffer to the local structure
	mov edx,[pPoint]
	mov eax,[pMem]
	mov eax,[eax]
	mov [edx],eax
	mov eax,[pMem]
	mov eax,[eax+4]
	mov [edx+4],eax

	invoke Free,[pMem]

	RET
ENDF

GetRemoteItem9x FRAME hlv,pLVItem
	uses ebx,edi,esi
	LOCAL pMem		:D

	mov edi,[pLVItem]
	; Calculate the size of buffer needed
	mov ecx,SIZEOF LV_ITEM
	add ecx,[edi+LV_ITEM.cchTextMax]
	inc ecx

	; Allocate memory on the shared heap
	invoke Alloc,ecx
	mov [pMem],eax

	; Substitute the address of the local pszText buffer for the shared one
	mov esi,eax
	add esi,SIZEOF LV_ITEM

	mov ebx,[edi+LV_ITEM.pszText]
	mov [edi+LV_ITEM.pszText],esi

	; Write the LV_ITEM structure to the shared buffer
	invoke MemCopy,[pLVItem],[pMem],SIZEOF LV_ITEM

	; Get the item info, using the shared buffer
	invoke SendMessage,[hlv],LVM_GETITEM,0,[pMem]

	; Copy the shared LV_ITEM into our local LV_ITEM
	invoke MemCopy,[pMem],[pLVItem],SIZEOF LV_ITEM

	; Reset the address of the pszText buffer
	mov [edi+LV_ITEM.pszText],ebx

	; Copy the text from the shared buffer
	invoke MemCopy,esi,ebx,[edi+LV_ITEM.cchTextMax]

	invoke Free,[pMem]

	RET
ENDF

MemCopy FRAME lpSource,lpDest,nBytes
	uses edi,esi,ecx
	cld
	mov edi,[lpDest]
	mov esi,[lpSource]
	mov ecx,[nBytes]

	; do the evenly divisible ones
	shr ecx,2
	rep movsd

	; do the remainder
	mov ecx,[nBytes]
	and ecx,3
	rep movsb

	RET
ENDF

GetItemPosNT FRAME hlv,iItem,pPoint
	LOCAL pMem		:D
	LOCAL PID		:D
	LOCAL hProcess	:D
	LOCAL cbWritten	:D

	; Get the ID of the process that created the desktop listview
	invoke [pGetWindowThreadProcessId],[hlv],OFFSET PID

	; Open the process with Virtual memory priviledges
	invoke OpenProcess,PROCESS_VM_OPERATION \
		+ PROCESS_VM_READ + PROCESS_VM_WRITE,NULL,[PID]
	mov [hProcess],eax

	; Create a buffer inside the process space of the desktop listview
	invoke [pVirtualAllocEx],eax,NULL,8,MEM_COMMIT,PAGE_READWRITE
	mov [pMem],eax

	; Get the item position and place it in the remote buffer
	invoke SendMessage,[hlv],LVM_GETITEMPOSITION,[iItem],[pMem]

	; Copy the remote buffer to the local structure
	invoke [pReadProcessMemory],[hProcess],[pMem],[pPoint],\
		8,OFFSET cbWritten

	; Clean up and leave
	invoke [pVirtualFreeEx],[hProcess],[pMem],0,MEM_RELEASE
	invoke CloseHandle,[hProcess]

	RET
ENDF

GetRemoteItemNT FRAME hlv,pLVItem
	uses ebx,edi,esi
	LOCAL pMem		:D
	LOCAL PID		:D
	LOCAL hProcess	:D
	LOCAL cbWritten	:D

	; Get the ID of the process that created the desktop listview
	invoke [pGetWindowThreadProcessId],[hlv],OFFSET PID

	; Open the process with Virtual memory priviledges
	invoke OpenProcess,PROCESS_VM_OPERATION \
		+ PROCESS_VM_READ + PROCESS_VM_WRITE,NULL,[PID]
	mov [hProcess],eax

	mov edi,[pLVItem]

	; Calculate the size of buffer needed
	mov ecx,SIZEOF LV_ITEM
	add ecx,[edi+LV_ITEM.cchTextMax]
	inc ecx

	; Create a buffer inside the process space of the desktop listview
	invoke [pVirtualAllocEx],eax,NULL,ecx,MEM_COMMIT,PAGE_READWRITE
	mov [pMem],eax

	; Substitute the address of the local pszText buffer for the remote one
	mov esi,eax
	add esi,SIZEOF LV_ITEM

	mov ebx,[edi+LV_ITEM.pszText]
	mov [edi+LV_ITEM.pszText],esi

	; Write the LV_ITEM structure to the remote process buffer
	invoke [pWriteProcessMemory],[hProcess],[pMem],\
		[pLVItem],SIZEOF LV_ITEM,OFFSET cbWritten

	; Get the item info, using the remote buffer
	invoke SendMessage,[hlv],LVM_GETITEM,0,[pMem]

	; Copy the remote LV_ITEM into our local LV_ITEM 
	invoke [pReadProcessMemory],[hProcess],[pMem],\
		[pLVItem],SIZEOF LV_ITEM,OFFSET cbWritten

	; Reset the address of the pszText buffer
	mov [edi+LV_ITEM.pszText],ebx

	; Copy the text from the remote buffer
	invoke [pReadProcessMemory],[hProcess],esi,ebx,\
		[edi+LV_ITEM.cchTextMax],OFFSET cbWritten

	; Free the memory and close the remote process
	invoke [pVirtualFreeEx],[hProcess],[pMem],0,MEM_RELEASE
	invoke CloseHandle,[hProcess]

	RET
ENDF
